/*
# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Santé)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------  
*/

/*=========================================================================
Program:   bbtk
Module:    $RCSfile$
Language:  C++
Date:      $Date$
Version:   $Revision$
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and
*  abiding by the rules of distribution of free software. You can  use,
*  modify and/ or redistribute the software under the terms of the CeCILL-B
*  license as circulated by CEA, CNRS and INRIA at the following URL
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability.
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */

/**
*  \file
*  \brief Class bbtk::GBoxController
*/


#include "GBoxController.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif
namespace bbtk
{


	//=========================================================================
	GBoxController::GBoxController()
	{

	}

	//=========================================================================
	GBoxController::~GBoxController()
	{
	}
	//=========================================================================

	bool GBoxController::OnMouseMove()
	{

		if ( _vtkInteractorStyleBaseView!=NULL)
		{
			int X,Y;
			crea::wxVTKRenderWindowInteractor *_wxVTKiren;
			_wxVTKiren = _vtkInteractorStyleBaseView->GetWxVtk3DBaseView()->GetWxVTKRenderWindowInteractor();
			_wxVTKiren->GetEventPosition( X , Y );

			int state  = _view->getState();

			//Evaluate new state

			if(state == NOTHING_HAPPENS)
			{
				if(_view->isPointInside(X,Y))
				{
					_view->setState(HIGHLIGHTED);
				}
			}
			if( state==HIGHLIGHTED)
			{
				if(!_view->isPointInside(X,Y))
				{
					_view->setState(NOTHING_HAPPENS);
				}
			}

			_model->notifyObservers(getId());

		}
		return true;
	}

	//=========================================================================

	bool GBoxController::OnLeftButtonDown()
	{
	    bool ok=true;
		int state  = _view->getState();

		//Evaluate new state
		if(state == HIGHLIGHTED)
		{
		    ok=false;
			_isLeftClickDown=true;
			_view->setState(SELECTED);
			_model->notifyObservers(getId(),ADD_TO_SELECTED);
		}
		return ok;

	}

	//=========================================================================

	bool GBoxController::OnLeftButtonUp()
	{
		int X,Y;
		crea::wxVTKRenderWindowInteractor *wxVTKiren;
		wxVTKiren = _vtkInteractorStyleBaseView->GetWxVtk3DBaseView()->GetWxVTKRenderWindowInteractor();
		wxVTKiren->GetEventPosition(X,Y);

		int state  = _view->getState();
		//Evaluate new state
		if(_isLeftClickDown)
		{
			_isLeftClickDown=false;
			if(_view->isPointInside(X,Y))
			{
				// It is supposed that I'm always inside even if the box is in drag
				_view->setState(SELECTED);
				_model->notifyObservers(getId());
			}
		}
	return true;

	}

	//=========================================================================

	bool GBoxController::OnRightButtonUp()
	{
		return true;
	}

	//=========================================================================

	bool GBoxController::OnMiddleButtonDown()
	{
		return true;
	}

	//=========================================================================

}  // EO namespace bbtk

// EOF

